import {
  Annotation,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

import {
  Decorator,
} from '@overflow/commons/decorator';

export interface ParameterAnnotationAttributes {
  name?: string;
}

export class ParameterAnnotation implements Annotation {
  public readonly attributes: ParameterAnnotationAttributes;

  public constructor(name: string | ParameterAnnotationAttributes) {
    if (undefined === name) {
      this.attributes = {
        name: '',
      };
      return;
    }

    if (TypeUtil.isString(name)) {
      this.attributes = {
        name: <string>name,
      };
    } else {
      this.attributes = <ParameterAnnotationAttributes>name;
    }
  }

  public parameterDecorator?(target: Object, propertyKey: PropertyKeyType, parameterIndex: number): void {
    console.log('Parameter');
  }
}

export const Parameter = Decorator.create(ParameterAnnotation);
